summaryrefslogtreecommitdiffstats
path: root/jjb/releng/generate-job-list.sh
diff options
context:
space:
mode:
authorTrevor Bramwell <tbramwell@linuxfoundation.org>2017-05-19 14:23:54 -0700
committerTrevor Bramwell <tbramwell@linuxfoundation.org>2017-07-12 16:38:15 -0700
commit97b70892a76351da03f981ff4559aabfed0e0840 (patch)
tree75a1e19d7871ff00aeb71be793061d429e26b53e /jjb/releng/generate-job-list.sh
parent1bfef523c2abd5024e2ec95a2fec3262178d1949 (diff)
Comment Pending JJB Changes on Patchset
After submitting a releng patchset a comment listing the jobs that are added, modified, or deleted by the change will be posted to the review. Change-Id: I53562c9ad5b0185d3dfe354e265e250c7e9f7f72 Signed-off-by: Trevor Bramwell <tbramwell@linuxfoundation.org>
Diffstat (limited to 'jjb/releng/generate-job-list.sh')
-rwxr-xr-xjjb/releng/generate-job-list.sh68
1 files changed, 68 insertions, 0 deletions
diff --git a/jjb/releng/generate-job-list.sh b/jjb/releng/generate-job-list.sh
new file mode 100755
index 000000000..b32a514e5
--- /dev/null
+++ b/jjb/releng/generate-job-list.sh
@@ -0,0 +1,68 @@
+#! /bin/bash
+set -o errexit
+set -o nounset
+set -o pipefail
+
+# SPDX-license-identifier: Apache-2.0
+##############################################################################
+# Copyright (c) 2016 Linux Foundation and others.
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+##############################################################################
+
+# Job Number Formatter
+function JOBS {
+ local NUMS=$1
+ if [ $NUMS == 1 ]; then
+ echo -n "Job"
+ else
+ echo -n "Jobs"
+ fi
+}
+
+# We expect job_output to exist prior to this being run and contain the
+# output from jenkins-jobs test
+
+echo "> Generating list of previous JJB jobs..."
+git checkout -q -b previous-commit HEAD^
+jenkins-jobs -l ERROR test -r jjb -o job_output_prev
+git checkout -q - && git branch -q -d previous-commit
+
+echo "> Finding job changes ..."
+diff -r -q job_output job_output_prev &> job_diff.txt || true
+
+# Only in (job_output) = NEW
+# Only in (job_output_prev) = DELETED
+# Files ... differ = MODIFIED
+
+declare -a JOBS_ADDED=($(grep 'job_output:' job_diff.txt | cut -d':' -f2- | sed 's/^[ \t]*//;s/[ \t]*$//'))
+declare -a JOBS_MODIFIED=($(grep 'differ$' job_diff.txt | sed "s/Files job_output\/\(.*\) and.*/\1/g"))
+declare -a JOBS_REMOVED=($(grep 'job_output_prev:' job_diff.txt | cut -d ':' -f2- | sed 's/^[ \t]*//;s/[ \t]*$//'))
+
+NUM_JOBS_ADDED=${#JOBS_ADDED[@]}
+NUM_JOBS_MODIFIED=${#JOBS_MODIFIED[@]}
+NUM_JOBS_REMOVED=${#JOBS_REMOVED[@]}
+
+echo "> Writing gerrit comment ..."
+if [ $NUM_JOBS_ADDED -gt 0 ]; then
+ JOB_STRING="$(JOBS $NUM_JOBS_ADDED)"
+ { printf "Added %s %s:\n\n" "${NUM_JOBS_ADDED}" "$JOB_STRING";
+ printf '* %s\n' "${JOBS_ADDED[@]}";
+ printf "\n"; } >> gerrit_comment.txt
+fi
+
+if [ $NUM_JOBS_MODIFIED -gt 0 ]; then
+ JOB_STRING="$(JOBS $NUM_JOBS_MODIFIED)"
+ { printf "Modified %s %s:\n\n" "${NUM_JOBS_MODIFIED}" "$JOB_STRING";
+ printf '* %s\n' "${JOBS_MODIFIED[@]}";
+ printf "\n"; } >> gerrit_comment.txt
+fi
+
+if [ $NUM_JOBS_REMOVED -gt 0 ]; then
+ JOB_STRING="$(JOBS $NUM_JOBS_REMOVED)"
+ { printf "Removed %s %s:\n\n" "${NUM_JOBS_REMOVED}" "$JOB_STRING";
+ printf '* %s\n' "${JOBS_REMOVED[@]}";
+ printf "\n"; } >> gerrit_comment.txt
+fi